Index: LMDZ5/branches/testing/libf/phylmd/cv3_routines.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cv3_routines.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/cv3_routines.F90	(revision 2298)
@@ -5,5 +5,5 @@
 
 
-SUBROUTINE cv3_param(nd, delt)
+SUBROUTINE cv3_param(nd, k_upper, delt)
 
   use mod_phys_lmdz_para
@@ -36,6 +36,7 @@
   include "conema3.h"
 
-  INTEGER nd
-  REAL delt ! timestep (seconds)
+  INTEGER, INTENT(IN)              :: nd
+  INTEGER, INTENT(IN)              :: k_upper
+  REAL, INTENT(IN)                 :: delt ! timestep (seconds)
 
 
@@ -51,5 +52,10 @@
 ! -- limit levels for convection:
 
-  noff = 1
+!jyg<
+!  noff is chosen such that nl = k_upper so that upmost loops end at about 22 km
+!
+  noff = min(max(nd-k_upper, 1), (nd+1)/2)
+!!  noff = 1
+!>jyg
   minorig = 1
   nl = nd - noff
@@ -264,23 +270,22 @@
 
 !inputs:
-  INTEGER len, nd
-  LOGICAL ok_conserv_q
-  REAL t(len, nd), q(len, nd), p(len, nd)
-  REAL u(len, nd), v(len, nd)
-  REAL hm(len, nd), gz(len, nd)
-  REAL ph(len, nd+1)
-  REAL p1feed(len)
-! ,  wght(len)
-  REAL wght(nd)
+  INTEGER, INTENT (IN)                               :: len, nd
+  LOGICAL, INTENT (IN)                               :: ok_conserv_q
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: t, q, p
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: u, v
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: hm, gz
+  REAL, DIMENSION (len, nd+1), INTENT (IN)           :: ph
+  REAL, DIMENSION (len), INTENT (IN)                 :: p1feed
+  REAL, DIMENSION (nd), INTENT (IN)                  :: wght
 !input-output
-  REAL p2feed(len)
+  REAL, DIMENSION (len), INTENT (INOUT)              :: p2feed
 !outputs:
-  INTEGER iflag(len), nk(len), icb(len), icbmax
-!   real   wghti(len)
-  REAL wghti(len, nd)
-  REAL tnk(len), thnk(len), qnk(len), qsnk(len)
-  REAL unk(len), vnk(len)
-  REAL cpnk(len), hnk(len), gznk(len)
-  REAL plcl(len)
+  INTEGER, INTENT (OUT)                              :: icbmax
+  INTEGER, DIMENSION (len), INTENT (OUT)             :: iflag, nk, icb
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: wghti
+  REAL, DIMENSION (len), INTENT (OUT)                :: tnk, thnk, qnk, qsnk
+  REAL, DIMENSION (len), INTENT (OUT)                :: unk, vnk
+  REAL, DIMENSION (len), INTENT (OUT)                :: cpnk, hnk, gznk
+  REAL, DIMENSION (len), INTENT (OUT)                :: plcl
 
 !local variables:
@@ -514,22 +519,23 @@
 
 ! inputs:
-  INTEGER len, nd
-  INTEGER icb(len)
-  REAL t(len, nd), qs(len, nd), gz(len, nd)
-  REAL tnk(len), qnk(len), gznk(len)
-  REAL p(len, nd)
-  REAL plcl(len) ! convect3
+  INTEGER, INTENT (IN)                              :: len, nd
+  INTEGER, DIMENSION (len), INTENT (IN)             :: icb
+  REAL, DIMENSION (len, nd), INTENT (IN)            :: t, qs, gz
+  REAL, DIMENSION (len), INTENT (IN)                :: tnk, qnk, gznk
+  REAL, DIMENSION (len, nd), INTENT (IN)            :: p
+  REAL, DIMENSION (len), INTENT (IN)                :: plcl              ! convect3
 
 ! outputs:
-  REAL tp(len, nd), tvp(len, nd), clw(len, nd)
+  INTEGER, DIMENSION (len), INTENT (OUT)            :: icbs
+  REAL, DIMENSION (len, nd), INTENT (OUT)           :: tp, tvp, clw
 
 ! local variables:
   INTEGER i, k
-  INTEGER icb1(len), icbs(len), icbsmax2 ! convect3
+  INTEGER icb1(len), icbsmax2                                            ! convect3
   REAL tg, qg, alv, s, ahg, tc, denom, es, rg
   REAL ah0(len), cpp(len)
   REAL ticb(len), gzicb(len)
-  REAL qsicb(len) ! convect3
-  REAL cpinv(len) ! convect3
+  REAL qsicb(len)                                                        ! convect3
+  REAL cpinv(len)                                                        ! convect3
 
 ! -------------------------------------------------------------------
@@ -1051,21 +1057,24 @@
 
 !inputs:
-  INTEGER ncum, nd, nloc, j
-  INTEGER icb(nloc), icbs(nloc), nk(nloc)
-  REAL t(nloc, nd), q(nloc, nd), qs(nloc, nd), gz(nloc, nd)
-  REAL p(nloc, nd)
-  REAL tnk(nloc), qnk(nloc), gznk(nloc)
-  REAL hnk(nloc)
-  REAL lv(nloc, nd), lf(nloc, nd), tv(nloc, nd), h(nloc, nd)
-  REAL pbase(nloc), buoybase(nloc), plcl(nloc)
+  INTEGER, INTENT (IN)                               :: ncum, nd, nloc
+  INTEGER, DIMENSION (nloc), INTENT (IN)             :: icb, icbs, nk
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: t, q, qs, gz
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: p
+  REAL, DIMENSION (nloc), INTENT (IN)                :: tnk, qnk, gznk
+  REAL, DIMENSION (nloc), INTENT (IN)                :: hnk
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: lv, lf, tv, h
+  REAL, DIMENSION (nloc), INTENT (IN)                :: pbase, buoybase, plcl
+
+!input/outputs:
+  REAL, DIMENSION (nloc, nd), INTENT (INOUT)         :: tp, tvp, clw   ! Input for k = 1, icb+1 (computed in cv3_undilute1)
+                                                                       ! Output above
 
 !outputs:
-  INTEGER inb(nloc)
-  REAL tp(nloc, nd), tvp(nloc, nd), clw(nloc, nd)
-  REAL ep(nloc, nd), sigp(nloc, nd), hp(nloc, nd)
-  REAL buoy(nloc, nd)
+  INTEGER, DIMENSION (nloc), INTENT (OUT)            :: inb
+  REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: ep, sigp, hp
+  REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: buoy
 
 !local variables:
-  INTEGER i, k
+  INTEGER i, j, k
   REAL tg, qg, ahg, alv, alf, s, tc, es, esi, denom, rg, tca, elacrit
   REAL als
@@ -1084,6 +1093,4 @@
   DO k = 1, nl
     DO i = 1, ncum
-      ep(i, k) = 0.0
-      sigp(i, k) = spfac
       qi(i, k) = 0.
     END DO
@@ -1187,5 +1194,7 @@
           END IF
         END IF
-      END IF
+!jyg<
+!!      END IF  ! Endif moved to the end of the loop
+!>jyg
 
       IF (cvflag_ice) THEN
@@ -1258,5 +1267,7 @@
         END IF
       END IF ! (cvflag_ice)
-
+!jyg<
+      END IF ! (k>=(icbs(i)+1))
+!>jyg
     END DO
   END DO
@@ -1267,13 +1278,26 @@
 ! --- THESE MAY BE FUNCTIONS OF TP(I), P(I) AND CLW(I)
 ! =====================================================================
-
+!
+!jyg<
+  DO k = 1, nl
+    DO i = 1, ncum
+      ep(i, k) = 0.0
+      sigp(i, k) = spfac
+    END DO
+  END DO
+!>jyg
+!
   IF (flag_epkeorig/=1) THEN
     DO k = 1, nl ! convect3
       DO i = 1, ncum
-        pden = ptcrit - pbcrit
-        ep(i, k) = (plcl(i)-p(i,k)-pbcrit)/pden*epmax
-        ep(i, k) = max(ep(i,k), 0.0)
-        ep(i, k) = min(ep(i,k), epmax)
-        sigp(i, k) = spfac
+!jyg<
+       IF(k>=icb(i)) THEN
+!>jyg
+         pden = ptcrit - pbcrit
+         ep(i, k) = (plcl(i)-p(i,k)-pbcrit)/pden*epmax
+         ep(i, k) = max(ep(i,k), 0.0)
+         ep(i, k) = min(ep(i,k), epmax)
+!!         sigp(i, k) = spfac  ! jyg
+        ENDIF   ! (k>=icb(i))
       END DO
     END DO
@@ -1281,5 +1305,7 @@
     DO k = 1, nl
       DO i = 1, ncum
-        IF (k>=(nk(i)+1)) THEN
+        IF(k>=icb(i)) THEN
+!!        IF (k>=(nk(i)+1)) THEN
+!>jyg
           tca = tp(i, k) - t0
           IF (tca>=0.0) THEN
@@ -1292,9 +1318,10 @@
           ep(i, k) = max(ep(i,k), 0.0)
           ep(i, k) = min(ep(i,k), epmax)
-          sigp(i, k) = spfac
-        END IF
+!!          sigp(i, k) = spfac  ! jyg
+        END IF  ! (k>=icb(i))
       END DO
     END DO
   END IF
+!
 ! =====================================================================
 ! --- CALCULATE VIRTUAL TEMPERATURE AND LIFTED PARCEL
@@ -1331,6 +1358,7 @@
 ! first estimate of buoyancy:
 
-  DO i = 1, ncum
-    DO k = 1, nl
+!jyg : k-loop outside i-loop (07042015)
+  DO k = 1, nl
+    DO i = 1, ncum
       buoy(i, k) = tvp(i, k) - tv(i, k)
     END DO
@@ -1340,10 +1368,13 @@
 ! for safety, set buoy(icb)=buoybase
 
-  DO i = 1, ncum
-    DO k = 1, nl
+!jyg : k-loop outside i-loop (07042015)
+  DO k = 1, nl
+    DO i = 1, ncum
       IF ((k>=icb(i)) .AND. (k<=nl) .AND. (p(i,k)>=pbase(i))) THEN
         buoy(i, k) = buoybase(i)
       END IF
     END DO
+  END DO
+  DO i = 1, ncum
 !    buoy(icb(i),k)=buoybase(i)
     buoy(i, icb(i)) = buoybase(i)
@@ -1490,21 +1521,30 @@
   END DO
 
-  DO k = minorig + 1, nl
-    DO i = 1, ncum
-      IF ((k>=icb(i)) .AND. (k<=inb(i))) THEN
-
-        IF (cvflag_ice) THEN
+!jyg : cvflag_ice test outside the loops (07042015)
+!
+  IF (cvflag_ice) THEN
+!
+    DO k = minorig + 1, nl
+      DO i = 1, ncum
+        IF ((k>=icb(i)) .AND. (k<=inb(i))) THEN
           frac(i, k) = 1. - (t(i,k)-243.15)/(263.15-243.15)
           frac(i, k) = min(max(frac(i,k),0.0), 1.0)
           hp(i, k) = hnk(i) + (lv(i,k)+(cpd-cpv)*t(i,k)+frac(i,k)*lf(i,k))* &
                               ep(i, k)*clw(i, k)
-
-        ELSE
+        END IF
+      END DO
+    END DO
+!
+  ELSE
+!
+    DO k = minorig + 1, nl
+      DO i = 1, ncum
+        IF ((k>=icb(i)) .AND. (k<=inb(i))) THEN
           hp(i, k) = hnk(i) + (lv(i,k)+(cpd-cpv)*t(i,k))*ep(i, k)*clw(i, k)
         END IF
-
-      END IF
-    END DO
-  END DO
+      END DO
+    END DO
+!
+  END IF  ! (cvflag_ice)
 
   RETURN
@@ -1768,25 +1808,24 @@
 
 !inputs:
-  INTEGER ncum, nd, na, ntra, nloc
-  INTEGER icb(nloc), inb(nloc), nk(nloc)
-  REAL sig(nloc, nd)
-  REAL qnk(nloc), unk(nloc), vnk(nloc)
-  REAL ph(nloc, nd+1)
-  REAL t(nloc, nd), rr(nloc, nd), rs(nloc, nd)
-  REAL u(nloc, nd), v(nloc, nd)
-  REAL tra(nloc, nd, ntra) ! input of convect3
-  REAL lv(nloc, na), h(nloc, na), hp(nloc, na)
-  REAL lf(nloc, na), frac(nloc, na)
-  REAL tv(nloc, na), tvp(nloc, na), ep(nloc, na), clw(nloc, na)
-  REAL m(nloc, na) ! input of convect3
+  INTEGER, INTENT (IN)                               :: ncum, nd, na, ntra, nloc
+  INTEGER, DIMENSION (nloc), INTENT (IN)             :: icb, inb, nk
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: sig
+  REAL, DIMENSION (nloc), INTENT (IN)                :: qnk, unk, vnk
+  REAL, DIMENSION (nloc, nd+1), INTENT (IN)          :: ph
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: t, rr, rs
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: u, v
+  REAL, DIMENSION (nloc, nd, ntra), INTENT (IN)      :: tra               ! input of convect3
+  REAL, DIMENSION (nloc, na), INTENT (IN)            :: lv, h, hp
+  REAL, DIMENSION (nloc, na), INTENT (IN)            :: lf, frac
+  REAL, DIMENSION (nloc, na), INTENT (IN)            :: tv, tvp, ep, clw
+  REAL, DIMENSION (nloc, na), INTENT (IN)            :: m                 ! input of convect3
 
 !outputs:
-  REAL ment(nloc, na, na), qent(nloc, na, na)
-  REAL uent(nloc, na, na), vent(nloc, na, na)
-  REAL sij(nloc, na, na), elij(nloc, na, na)
-  REAL traent(nloc, nd, nd, ntra)
-  REAL ments(nloc, nd, nd), qents(nloc, nd, nd)
-  REAL sigij(nloc, nd, nd)
-  INTEGER nent(nloc, nd)
+  REAL, DIMENSION (nloc, na, na), INTENT (OUT)        :: ment, qent
+  REAL, DIMENSION (nloc, na, na), INTENT (OUT)        :: uent, vent
+  REAL, DIMENSION (nloc, na, na), INTENT (OUT)        :: sij, elij
+  REAL, DIMENSION (nloc, nd, nd, ntra), INTENT (OUT)  :: traent
+  REAL, DIMENSION (nloc, nd, nd), INTENT (OUT)        :: ments, qents
+  INTEGER, DIMENSION (nloc, nd), INTENT (OUT)         :: nent
 
 !local variables:
@@ -1797,4 +1836,5 @@
   REAL asij(nloc), smax(nloc), scrit(nloc)
   REAL asum(nloc, nd), bsum(nloc, nd), csum(nloc, nd)
+  REAL sigij(nloc, nd, nd)
   REAL wgh
   REAL zm(nloc, na)
@@ -2184,4 +2224,5 @@
   include "cv3param.h"
   include "cvflag.h"
+  include "nuage.h"
 
 !inputs:
@@ -2363,5 +2404,6 @@
 
           IF (cvflag_ice) THEN
-            thaw = (t(il,i)-273.15)/(275.15-273.15)
+!CR:tmax_fonte_cv: T for which ice is totally melted (used to be 275.15)
+            thaw = (t(il,i)-273.15)/(tmax_fonte_cv-273.15)
             thaw = min(max(thaw,0.0), 1.0)
             frac(il, i) = frac(il, i)*(1.-thaw)
@@ -2477,5 +2519,6 @@
           f6 = -100.*sigd(il)*bfac*(ph(il,i)-ph(il,i+1))*evap(il, i)
 
-          thaw = (t(il,i)-273.15)/(275.15-273.15)
+!CR:tmax_fonte_cv: T for which ice is totally melted (used to be 275.15)
+          thaw = (t(il,i)-273.15)/(tmax_fonte_cv-273.15)
           thaw = min(max(thaw,0.0), 1.0)
           water(il, i) = water(il, i+1) + (1-fraci(il,i))*d6
@@ -2763,5 +2806,6 @@
                      iflag, precip, Vprecip, ft, fr, fu, fv, ftra, &
                      cbmf, upwd, dnwd, dnwd0, ma, mip, &
-                     tls, tps, qcondc, wd, &
+!!                     tls, tps,                             ! useless . jyg
+                     qcondc, wd, &
                      ftd, fqd, qnk, qtc, sigt, tau_cld_cv, coefw_cld_cv)
 
@@ -2811,5 +2855,5 @@
       REAL dnwd0(nloc, nd), mip(nloc, nd)
       REAL Vprecip(nloc, nd+1)
-      REAL tls(nloc, nd), tps(nloc, nd)
+!!      REAL tls(nloc, nd), tps(nloc, nd)                 ! useless . jyg
       REAL qcondc(nloc, nd) ! cld
       REAL qtc(nloc,nd), sigt(nloc,nd) ! cld
@@ -2823,5 +2867,5 @@
       REAL cpinv, rdcp, dpinv
       REAL awat(nloc)
-      REAL lvcp(nloc, na), lfcp(nloc, na), mke(nloc, na)
+      REAL lvcp(nloc, na), lfcp(nloc, na)                  ! , mke(nloc, na) ! unused . jyg
       REAL am(nloc), work(nloc), ad(nloc), amp1(nloc)
 !!      real up1(nloc), dn1(nloc)
@@ -3588,6 +3632,11 @@
 ! ***           reset counter and return           ***
 
+! Reset counter only for points actually convective (jyg)
+! In order take into account the possibility of changing the compression,
+! reset m, sig and w0 to zero for non-convecting points.
   DO il = 1, ncum
-    sig(il, nd) = 2.0
+    IF (iflag(il) < 3) THEN
+      sig(il, nd) = 2.0
+    ENDIF
   END DO
 
@@ -3743,17 +3792,17 @@
 ! ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 
-  DO i = 1, nd
-    DO il = 1, ncum
-      mke(il, i) = upwd(il, i) + dnwd(il, i)
-    END DO
-  END DO
-
-  DO i = 1, nd
-    DO il = 1, ncum
-      rdcp = (rrd*(1.-rr(il,i))-rr(il,i)*rrv)/(cpd*(1.-rr(il,i))+rr(il,i)*cpv)
-      tls(il, i) = t(il, i)*(1000.0/p(il,i))**rdcp
-      tps(il, i) = tp(il, i)
-    END DO
-  END DO
+!!  DO i = 1, nd                                  ! unused . jyg
+!!    DO il = 1, ncum                             ! unused . jyg
+!!      mke(il, i) = upwd(il, i) + dnwd(il, i)    ! unused . jyg
+!!    END DO                                      ! unused . jyg
+!!  END DO                                        ! unused . jyg
+
+!!  DO i = 1, nd                                                                 ! unused . jyg
+!!    DO il = 1, ncum                                                            ! unused . jyg
+!!      rdcp = (rrd*(1.-rr(il,i))-rr(il,i)*rrv)/(cpd*(1.-rr(il,i))+rr(il,i)*cpv) ! unused . jyg
+!!      tls(il, i) = t(il, i)*(1000.0/p(il,i))**rdcp                             ! unused . jyg
+!!      tps(il, i) = tp(il, i)                                                   ! unused . jyg
+!!    END DO                                                                     ! unused . jyg
+!!  END DO                                                                       ! unused . jyg
 
 
Index: LMDZ5/branches/testing/libf/phylmd/cv3a_compress.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cv3a_compress.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/cv3a_compress.F90	(revision 2298)
@@ -1,11 +1,23 @@
-SUBROUTINE cv3a_compress(len, nloc, ncum, nd, ntra, iflag1, nk1, icb1, icbs1, &
-    plcl1, tnk1, qnk1, gznk1, hnk1, unk1, vnk1, wghti1, pbase1, buoybase1, &
-    t1, q1, qs1, t1_wake, q1_wake, qs1_wake, s1_wake, u1, v1, gz1, th1, &
-    th1_wake, tra1, h1, lv1, lf1, cpn1, p1, ph1, tv1, tp1, tvp1, clw1, &
-    h1_wake, lv1_wake, lf1_wake, cpn1_wake, tv1_wake, sig1, w01, ptop21, &
-    ale1, alp1, omega1, iflag, nk, icb, icbs, plcl, tnk, qnk, gznk, hnk, unk, vnk, &
-    wghti, pbase, buoybase, t, q, qs, t_wake, q_wake, qs_wake, s_wake, u, v, &
-    gz, th, th_wake, tra, h, lv, lf, cpn, p, ph, tv, tp, tvp, clw, h_wake, &
-    lv_wake, lf_wake, cpn_wake, tv_wake, sig, w0, ptop2, ale, alp, omega)
+SUBROUTINE cv3a_compress(len, nloc, ncum, nd, ntra, compress, &
+                         iflag1, nk1, icb1, icbs1, &
+                         plcl1, tnk1, qnk1, gznk1, hnk1, unk1, vnk1, &
+                         wghti1, pbase1, buoybase1, &
+                         t1, q1, qs1, t1_wake, q1_wake, qs1_wake, s1_wake, &
+                         u1, v1, gz1, th1, th1_wake, &
+                         tra1, &
+                         h1, lv1, lf1, cpn1, p1, ph1, tv1, tp1, tvp1, clw1, &
+                         h1_wake, lv1_wake, lf1_wake, cpn1_wake, tv1_wake, &
+                         sig1, w01, ptop21, &
+                         Ale1, Alp1, omega1, &
+                         iflag, nk, icb, icbs, &
+                         plcl, tnk, qnk, gznk, hnk, unk, vnk, &
+                         wghti, pbase, buoybase, &
+                         t, q, qs, t_wake, q_wake, qs_wake, s_wake, &
+                         u, v, gz, th, th_wake, &
+                         tra, &
+                         h, lv, lf, cpn, p, ph, tv, tp, tvp, clw, &
+                         h_wake, lv_wake, lf_wake, cpn_wake, tv_wake, &
+                         sig, w0, ptop2, &
+                         Ale, Alp, omega)
   ! **************************************************************
   ! *
@@ -22,44 +34,58 @@
 
   ! inputs:
-  INTEGER len, nloc, ncum, nd, ntra
-  INTEGER iflag1(len), nk1(len), icb1(len), icbs1(len)
-  REAL plcl1(len), tnk1(len), qnk1(len), gznk1(len)
-  REAL hnk1(len), unk1(len), vnk1(len)
-  REAL wghti1(len, nd), pbase1(len), buoybase1(len)
-  REAL t1(len, nd), q1(len, nd), qs1(len, nd)
-  REAL t1_wake(len, nd), q1_wake(len, nd), qs1_wake(len, nd)
-  REAL s1_wake(len)
-  REAL u1(len, nd), v1(len, nd)
-  REAL gz1(len, nd), th1(len, nd), th1_wake(len, nd)
-  REAL tra1(len, nd, ntra)
-  REAL h1(len, nd), lv1(len, nd), lf1(len, nd), cpn1(len, nd)
-  REAL p1(len, nd), ph1(len, nd+1), tv1(len, nd), tp1(len, nd)
-  REAL tvp1(len, nd), clw1(len, nd)
-  REAL h1_wake(len, nd), lv1_wake(len, nd), cpn1_wake(len, nd)
-  REAL tv1_wake(len, nd), lf1_wake(len, nd)
-  REAL sig1(len, nd), w01(len, nd), ptop21(len)
-  REAL ale1(len), alp1(len)
-  REAL omega1(len,nd)
-
+  INTEGER, INTENT (IN)                               :: len, nloc, nd, ntra
+!jyg<
+  LOGICAL, INTENT (IN)                               :: compress  ! compression is performed if compress is true
+!>jyg
+  INTEGER, DIMENSION (len), INTENT (IN)              :: iflag1, nk1, icb1, icbs1
+  REAL, DIMENSION (len), INTENT (IN)                 :: plcl1, tnk1, qnk1, gznk1
+  REAL, DIMENSION (len), INTENT (IN)                 :: hnk1, unk1, vnk1
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: wghti1(len, nd)
+  REAL, DIMENSION (len), INTENT (IN)                 :: pbase1, buoybase1
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: t1, q1, qs1
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: t1_wake, q1_wake, qs1_wake
+  REAL, DIMENSION (len), INTENT (IN)                 :: s1_wake
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: u1, v1
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: gz1, th1, th1_wake
+  REAL, DIMENSION (len, nd,ntra), INTENT (IN)        :: tra1
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: h1, lv1, lf1, cpn1
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: p1
+  REAL, DIMENSION (len, nd+1), INTENT (IN)           :: ph1(len, nd+1)
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: tv1, tp1
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: tvp1, clw1
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: h1_wake, lv1_wake, cpn1_wake
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: tv1_wake, lf1_wake
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: sig1, w01
+  REAL, DIMENSION (len), INTENT (IN)                 :: ptop21
+  REAL, DIMENSION (len), INTENT (IN)                 :: Ale1, Alp1
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: omega1
+!
+  ! in/out 
+  INTEGER, INTENT (INOUT)                            :: ncum
+!
   ! outputs:
   ! en fait, on a nloc=len pour l'instant (cf cv_driver)
-  INTEGER iflag(len), nk(len), icb(len), icbs(len)
-  REAL plcl(len), tnk(len), qnk(len), gznk(len)
-  REAL hnk(len), unk(len), vnk(len)
-  REAL wghti(len, nd), pbase(len), buoybase(len)
-  REAL t(len, nd), q(len, nd), qs(len, nd)
-  REAL t_wake(len, nd), q_wake(len, nd), qs_wake(len, nd)
-  REAL s_wake(len)
-  REAL u(len, nd), v(len, nd)
-  REAL gz(len, nd), th(len, nd), th_wake(len, nd)
-  REAL tra(len, nd, ntra)
-  REAL h(len, nd), lv(len, nd), lf(len, nd), cpn(len, nd)
-  REAL p(len, nd), ph(len, nd+1), tv(len, nd), tp(len, nd)
-  REAL tvp(len, nd), clw(len, nd)
-  REAL h_wake(len, nd), lv_wake(len, nd), cpn_wake(len, nd)
-  REAL tv_wake(len, nd), lf_wake(len, nd)
-  REAL sig(len, nd), w0(len, nd), ptop2(len)
-  REAL ale(len), alp(len)
-  REAL omega(len,nd)
+  INTEGER, DIMENSION (nloc), INTENT (OUT)            ::  iflag, nk, icb, icbs
+  REAL, DIMENSION (nloc), INTENT (OUT)               ::  plcl, tnk, qnk, gznk
+  REAL, DIMENSION (nloc), INTENT (OUT)               ::  hnk, unk, vnk
+  REAL, DIMENSION (nloc, nd), INTENT (OUT)           ::  wghti
+  REAL, DIMENSION (nloc), INTENT (OUT)               ::  pbase, buoybase
+  REAL, DIMENSION (nloc, nd), INTENT (OUT)           ::  t, q, qs
+  REAL, DIMENSION (nloc, nd), INTENT (OUT)           ::  t_wake, q_wake, qs_wake
+  REAL, DIMENSION (nloc), INTENT (OUT)               ::  s_wake
+  REAL, DIMENSION (nloc, nd), INTENT (OUT)           ::  u, v
+  REAL, DIMENSION (nloc, nd), INTENT (OUT)           ::  gz, th, th_wake
+  REAL, DIMENSION (nloc, nd,ntra), INTENT (OUT)      ::  tra
+  REAL, DIMENSION (nloc, nd), INTENT (OUT)           ::  h, lv, lf, cpn
+  REAL, DIMENSION (nloc, nd), INTENT (OUT)           ::  p
+  REAL, DIMENSION (nloc, nd+1), INTENT (OUT)         ::  ph
+  REAL, DIMENSION (nloc, nd), INTENT (OUT)           ::  tv, tp
+  REAL, DIMENSION (nloc, nd), INTENT (OUT)           ::  tvp, clw
+  REAL, DIMENSION (nloc, nd), INTENT (OUT)           ::  h_wake, lv_wake, cpn_wake
+  REAL, DIMENSION (nloc, nd), INTENT (OUT)           ::  tv_wake, lf_wake
+  REAL, DIMENSION (nloc, nd), INTENT (OUT)           ::  sig, w0
+  REAL, DIMENSION (nloc), INTENT (OUT)               ::  ptop2
+  REAL, DIMENSION (nloc), INTENT (OUT)               ::  Ale, Alp
+  REAL, DIMENSION (nloc, nd), INTENT (OUT)           ::  omega
 
   ! local variables:
@@ -69,4 +95,7 @@
   CHARACTER (LEN=80) :: abort_message
 
+!jyg<
+  IF (compress) THEN
+!>jyg
 
   DO k = 1, nl + 1
@@ -108,5 +137,5 @@
     END DO
   END DO
-
+!
   ! AC!      do 121 j=1,ntra
   ! AC!ccccc      do 111 k=1,nl+1
@@ -146,7 +175,8 @@
       pbase(nn) = pbase1(i)
       buoybase(nn) = buoybase1(i)
+      sig(nn, nd) = sig1(i, nd)
       ptop2(nn) = ptop2(i)
-      ale(nn) = ale1(i)
-      alp(nn) = alp1(i)
+      Ale(nn) = Ale1(i)
+      Alp(nn) = Alp1(i)
     END IF
   END DO
@@ -157,4 +187,62 @@
     CALL abort_gcm(modname, abort_message, 1)
   END IF
+!
+!jyg<
+  ELSE  !(compress)
+!
+      ncum = len
+!
+      wghti(:,1:nl+1) = wghti1(:,1:nl+1)
+      t(:,1:nl+1) = t1(:,1:nl+1)
+      q(:,1:nl+1) = q1(:,1:nl+1)
+      qs(:,1:nl+1) = qs1(:,1:nl+1)
+      t_wake(:,1:nl+1) = t1_wake(:,1:nl+1)
+      q_wake(:,1:nl+1) = q1_wake(:,1:nl+1)
+      qs_wake(:,1:nl+1) = qs1_wake(:,1:nl+1)
+      u(:,1:nl+1) = u1(:,1:nl+1)
+      v(:,1:nl+1) = v1(:,1:nl+1)
+      gz(:,1:nl+1) = gz1(:,1:nl+1)
+      th(:,1:nl+1) = th1(:,1:nl+1)
+      th_wake(:,1:nl+1) = th1_wake(:,1:nl+1)
+      h(:,1:nl+1) = h1(:,1:nl+1)
+      lv(:,1:nl+1) = lv1(:,1:nl+1)
+      lf(:,1:nl+1) = lf1(:,1:nl+1)
+      cpn(:,1:nl+1) = cpn1(:,1:nl+1)
+      p(:,1:nl+1) = p1(:,1:nl+1)
+      ph(:,1:nl+1) = ph1(:,1:nl+1)
+      tv(:,1:nl+1) = tv1(:,1:nl+1)
+      tp(:,1:nl+1) = tp1(:,1:nl+1)
+      tvp(:,1:nl+1) = tvp1(:,1:nl+1)
+      clw(:,1:nl+1) = clw1(:,1:nl+1)
+      h_wake(:,1:nl+1) = h1_wake(:,1:nl+1)
+      lv_wake(:,1:nl+1) = lv1_wake(:,1:nl+1)
+      lf_wake(:,1:nl+1) = lf1_wake(:,1:nl+1)
+      cpn_wake(:,1:nl+1) = cpn1_wake(:,1:nl+1)
+      tv_wake(:,1:nl+1) = tv1_wake(:,1:nl+1)
+      sig(:,1:nl+1) = sig1(:,1:nl+1)
+      w0(:,1:nl+1) = w01(:,1:nl+1)
+      omega(:,1:nl+1) = omega1(:,1:nl+1)
+!
+      s_wake(:) = s1_wake(:)
+      iflag(:) = iflag1(:)
+      nk(:) = nk1(:)
+      icb(:) = icb1(:)
+      icbs(:) = icbs1(:)
+      plcl(:) = plcl1(:)
+      tnk(:) = tnk1(:)
+      qnk(:) = qnk1(:)
+      gznk(:) = gznk1(:)
+      hnk(:) = hnk1(:)
+      unk(:) = unk1(:)
+      vnk(:) = vnk1(:)
+      pbase(:) = pbase1(:)
+      buoybase(:) = buoybase1(:)
+      sig(:, nd) = sig1(:, nd)
+      ptop2(:) = ptop2(:)
+      Ale(:) = Ale1(:)
+      Alp(:) = Alp1(:)
+!
+  ENDIF !(compress)
+!>jyg
 
   RETURN
